// -- [usi_twi_slave.h ] ------------------------------------------------------
//		02.09.08
// 	AppNote      	: AVR312 - Using the USI module as a TWI slave
//                     angepasst: mit Prüfung von TWI_STOP
// 	Description    : Header file for USI_TWI driver
//		Tabwidth			: 3
//
// ----------------------------------------------------------------------------

#define TWI_RX_BUFFER_SIZE 32				
#define TWI_TX_BUFFER_SIZE 4
#define TRUE					1
#define FALSE 					0
#define TWI_SLAVE_ADR		0x40			// default-Adresse nach dem Neuprogrammieren
													// I/O-Registers: GPIOR0 .. 2, OCR0A, OCR0B, TCNT0, EEDR
#define USI_State 			GPIOR0		// benutzt I/O-Register als volatile Variable !!!
#define TWI_TxTail			GPIOR1		// benutzt I/O-Register als volatile Variable !!!
#define TWI_RxHead			GPIOR2		// benutzt I/O-Register als volatile Variable !!!
//#define General_Call						// Timer0 Register - ist zum Stromsparen abgeschaltet
//#define TWI_SlaveAdress 					// Register nicht benutzbar

//********** USI_TWI Prototypes **********//

void     usi_twi_slave_init(void);
void     eeprom_write_twi_adr(void);

uint8_t 	usi_twi_rx_bytes(void);
void 		usi_twi_put_data( uint8_t *,uint8_t );
void 		usi_twi_get_data( uint8_t *,uint8_t );

#define DDR_USI 		DDRB
#define PORT_USI 		PORTB
#define PIN_USI 		PINB
#define PORT_USI_SDA	PB0
#define PIN_USI_SDA 	PB0
#define PORT_USI_SCL	PB2
#define PIN_USI_SCL 	PB2

#define USI_WAIT		0x00
#define USI_STOP		0x01
#define USI_NACK		0x02

#define USI_ADR		0x10
#define USI_RECEIVE	0x20
#define USI_WRITE		0x40
